<?php
if (!isset($_GET["fen"])) {
 print '
  <html><head>
  <meta http-equiv="Content-Type" content="text/html; charset=windows-1251">
  <title>    Javascript</title>
  </head><body>
  <p>    Javascript ( "  ")
  <p>,      fen: http://url/genfen.php?fen=<a href="http://ru.wikipedia.org/wiki/FEN" target="_blank">FEN</a>
  <p>Javascript Drag-and-drop Chess FEN Position Builder (C) PerS, <a href="http://pers.narod.ru/jscript/js_dragdropchess.html" target="_blank">Script page (RU)</a>
  <p>Please use this script with parameter named "fen": http://url/genfen.php?fen=<a href="http://en.wikipedia.org/wiki/FEN" target="_blank">FEN</a>
  </p></body></html>
 ';
 exit;
}

$path = "./"; 
 //   ( URL)       GIF. 
 //     .    /
$size = 29; 
 //   ,      

function fen2diag($fen,$size,$path) {
 $diagram = imagecreatetruecolor ($size*8+2, $size*8+2);
 $fields = 0;
 $black = imagecolorallocate($diagram, 0, 0, 0);
 $white = imagecolorallocate($diagram, 255, 255, 255);
 $gray = imagecolorallocate($diagram, 170, 170, 170);
 imagefilledrectangle ($diagram, 0, 0, $size*8+2, $size*8+2, $white);
 imagefilledrectangle ($diagram, 0, 0, $size*8+2, $size*8+1, $black);
 $timg = imagecreatefromgif($path.'wp.gif');
 $imagesize = imagesx($timg);
 for ($x = 0; $x < 8; $x++) {
  for ($y = 0; $y < 8; $y++) {
   $color = ($x%2 == $y%2) ? $white : $gray;
   imagefilledrectangle($diagram, $size*$x+1, $size*$y+1, $size*$x+$size, $size*$y+$size, $color);
  }
 }

 $parts = explode(" ", $fen);
 $fen = $parts[0];
 $len = strlen($fen);
 for($i = 0; $i < $len; $i++) {
  if (strpos("12345678", $fen{$i}) !== false) $fields+=$fen{$i};
  elseif (strpos("kqrbnpKQRBNP", $fen{$i}) !== false) $fields++;
  elseif($fen{$i}==='/') {}
  else $fields +=100;
 }
 if ($fields > 64) {
  $fen = "8/8/8/8/8/8/8/8";
  $len = strlen($fen);
 }
 $fields = 0;
 for ($i = 0; $i < $len; $i++) {
  if (strpos("kqrbnp", $fen{$i}) !== false) {
   $piecepath = $path.'b'.$fen{$i}.'.gif';
   $piece = imagecreatefromgif ($piecepath);
   $posy = $size*($fields >> 3)+1;
   $posx = $size*($fields % 8)+1;
   $fields++;
   imagecopy ($diagram, $piece, $posx, $posy, 0, 0, $imagesize, $imagesize);
  }
  elseif (strpos("KQRBNP", $fen{$i}) !== false) {
   $piecepath = $path.'w'.strtolower($fen{$i}).'.gif';
   $piece = imagecreatefromgif ($piecepath);
   $posy = $size*($fields >> 3)+1;
   $posx = $size*($fields % 8)+1;
   $fields++;
   imagecopy ($diagram, $piece, $posx, $posy, 0, 0, $imagesize, $imagesize);
  }
  elseif ($fen{$i} >= "0" and $fen{$i} <= "9") {
   $fields += $fen{$i};
  }
 }
 return $diagram;
}

$src = fen2diag(trim($_GET["fen"]),$size,$path);

header('Content-type: image/gif');
imagegif ($src);
?>